/**
 * Sample code for "Untestable Code" serie. Find more on
 * http://kaczanowscy.pl/tomek.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including * without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
package pl.kaczanowscy.uc.domain;

import java.math.BigDecimal;
import java.util.List;

import pl.kaczanowscy.uc.infrastructure.Database;

/**
 * This class taken from jmockit tutorial by Rogério Liesenfeld.
 * 
 * @author Tomek Kaczanowski
 * 
 */
public final class ServiceA
{
   public void doBusinessOperationXyz(EntityX data) throws InvalidItemStatus
   {
      List items = Database.find(
         "select item from EntityY item where item.someProperty=?",
         data.getSomeProperty());

      BigDecimal total = new ServiceB().computeTotal(items);

      data.setTotal(total);
      Database.save(data);
   }
}
